﻿Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Private Sub UltraGrid1_InitializeLayout(sender As System.Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        e.Layout.Override.MergedCellStyle = Infragistics.Win.UltraWinGrid.MergedCellStyle.Always
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
        Dim checkbox As CheckBox = CType(sender, CheckBox)

        If (checkbox.Checked) Then
            Dim myMergedCellEvaluator = New MyMergedCellEvaluator()
            Me.UltraGrid1.DisplayLayout.Bands(0).Columns("Col2").MergedCellEvaluator = myMergedCellEvaluator
        Else
            Me.UltraGrid1.DisplayLayout.Bands(0).Columns("Col2").MergedCellEvaluator = Nothing
        End If

    End Sub
End Class

Public Class MyMergedCellEvaluator
    Implements IMergedCellEvaluator

    Public Function ShouldCellsBeMerged(row1 As Infragistics.Win.UltraWinGrid.UltraGridRow, row2 As Infragistics.Win.UltraWinGrid.UltraGridRow, column As Infragistics.Win.UltraWinGrid.UltraGridColumn) As Boolean Implements Infragistics.Win.UltraWinGrid.IMergedCellEvaluator.ShouldCellsBeMerged

        Dim xCol1 As String = row1.Cells("col1").Text
        Dim yCol1 As String = row2.Cells("col1").Text

        If String.Compare(xCol1, yCol1) <> 0 Then
            Return False
        End If

        Dim xCol2 As String = row1.Cells("col2").Text
        Dim yCol2 As String = row2.Cells("col2").Text

        If String.Compare(xCol2, yCol2) <> 0 Then
            Return False
        End If

        Return True
    End Function
End Class



